
public class EditDistance {
	public static int dist[][];
	
	public static int recompute(String a, String b, int theta, boolean cutoff) {
		int j = b.length();
		
		int temp = b.length()-theta;
		if(temp < 1)
			temp = 1;
		if(temp > a.length())
			temp = a.length();
		int I = temp;
		
		temp = b.length()+theta;
		if(temp < 1)
			temp = 1;
		if(temp > a.length())
			temp = a.length();
		int J = temp;
		
		int min = 10000000;
		
		dist[0][j] = j;
		for(int i=(cutoff ? 1 : J+1);i<=(cutoff ? J : a.length());i++) {
			if(a.charAt(i-1) == b.charAt(j-1)) {
				dist[i][j] = dist[i-1][j-1];
			}
			else if(i >= 2 && j >= 2 && a.charAt(i-2) == b.charAt(j-1) && a.charAt(i-1) == b.charAt(j-2)) {
				temp = dist[i-2][j-2];
				temp = temp < dist[i][j-1] ? temp : dist[i][j-1];
				temp = temp < dist[i-1][j] ? temp : dist[i-1][j];
				dist[i][j] = 1+temp;
			}
			else {
				temp = dist[i-1][j-1];
				temp = temp < dist[i][j-1] ? temp : dist[i][j-1];
				temp = temp < dist[i-1][j] ? temp : dist[i-1][j];
				dist[i][j] = 1+temp;
			}
			
			if(i >= I && i <= J)  {
				if(dist[i][j] < min)
					min = dist[i][j];
			}
		}
		
		if(cutoff)
			return min;
		else
			return dist[a.length()][b.length()];
	}
	
	public static int compute(String a, String b) {
		dist = new int[20][20];
		
		for(int i=0;i<=a.length();i++) {
			dist[i][0] = i;
		}
		for(int j=1;j<=b.length();j++) {
			dist[0][j] = j;
			for(int i=1;i<=a.length();i++) {
				if(a.charAt(i-1) == b.charAt(j-1)) {
					dist[i][j] = dist[i-1][j-1];
				}
				else if(i >= 2 && j >= 2 && a.charAt(i-2) == b.charAt(j-1) && a.charAt(i-1) == b.charAt(j-2)) {
					int temp = dist[i-2][j-2];
					temp = temp < dist[i][j-1] ? temp : dist[i][j-1];
					temp = temp < dist[i-1][j] ? temp : dist[i-1][j];
					dist[i][j] = 1+temp;
				}
				else {
					int temp = dist[i-1][j-1];
					temp = temp < dist[i][j-1] ? temp : dist[i][j-1];
					temp = temp < dist[i-1][j] ? temp : dist[i-1][j];
					dist[i][j] = 1+temp;
				}
			}
		}
		return dist[a.length()][b.length()];
	}
	
	public static void main(String args[]) {
		System.out.println(compute("ababa",""));
		System.out.println(recompute("ababa","a",1,true));
		System.out.println(recompute("ababa","ab",1,true));
		System.out.println(recompute("ababa","aba",1,true));
		System.out.println(recompute("ababa","abaa",1,true));
		System.out.println(recompute("ababa","abaab",1,true));
		System.out.println(recompute("ababa","abaaba",1,true));
		System.out.println(recompute("ababa","abaabaa",1,true));
		System.out.println(recompute("ababa","abaabaab",1,true));
	}
}
