import java.util.*;

class Triple {
	String a;
	char b;
	int c;
	
	Triple(String p_a, char p_b, int p_c) {
		a = p_a;
		b = p_b;
		c = p_c;
	}
}

public class SpellCorrector {
	public static void main(String args[]) {
		String X = "abba";
		int theta = 2;
		
		FSA.init();
		EditDistance.compute(X,"");
		
		Stack<Triple> s = new Stack<Triple>();
		Triple obj = new Triple("",(char)32,1);
	
		s.push(obj);
		
		while(!s.empty()) {
			Triple curt = s.pop();
			
			//System.out.println("String " + curt.a + ", char " + curt.b + ", state " + curt.c);
			
			if('a' > curt.b && FSA.next_state(curt.c, 'a') != 0) {
				Triple prov_t = new Triple(curt.a,'a',curt.c);
				s.push(prov_t);
				
				String prov_st = curt.a + 'a';
				if(EditDistance.recompute(X, prov_st, theta, true) <= theta) {
					prov_t = new Triple(prov_st,(char)32,FSA.next_state(curt.c,'a'));
					s.push(prov_t);
					if(EditDistance.recompute(X, prov_st, theta, false) <= theta && FSA.is_final(prov_t.c))
						System.out.println(prov_st);
				}
			}
			else if('b' > curt.b && FSA.next_state(curt.c, 'b') != 0) {
				Triple prov_t = new Triple(curt.a,'b',curt.c);
				s.push(prov_t);
				
				String prov_st = curt.a + 'b';
				if(EditDistance.recompute(X, prov_st, theta, true) <= theta) {
					prov_t = new Triple(prov_st,(char)32,FSA.next_state(curt.c,'b'));
					s.push(prov_t);
					if(EditDistance.recompute(X, prov_st, theta, false) <= theta && FSA.is_final(prov_t.c))
						System.out.println(prov_st);
				}
			}
		}
	}
}
